# En este script se calcula el balance estructural para el año 2023 utilizando
# como insumos los cálculos en los scripts anteriores que calculan el ajuste 
# cíclico de los componentes de ingresos que se ajustan.

# Referencias
a <- bca$ac
b <- datos$eeoo

# Ajuste cíclico total
ac_total <- data.frame(
  ac_total = a$itnm_ac$itnm_ac_total                 +
             a$iprevsalud_ac                         +
             a$cobre_ac                              +
             a$gmp10_ac$ir_gmp10_ac$ir_gmp10_ac      +
             a$gmp10_ac$ie_gmp10_ac$ie_gmp10_ac      +
             a$gmp10_ac$ia_gmp10_ac$ia_gmp10_ac   
)
# Ingresos estructurales totales
i_str_total <- data.frame(
  i_str_total = b$i - ac_total$ac_total)

# Balance efectivo
bef <- data.frame(
  bef = b$i - b$g
)
# Balance estructural
be <- data.frame(
  be = i_str_total$i_str_total - b$g
)


##########
#####
#


bca$i_str$i_str_total <- i_str_total$i_str_total
bca$ac$ac_total       <- ac_total$ac_total
bca$g   <- b$g
bca$bef <- bef$bef
bca$be  <- be$be
rm(a,b)
rm(ac_total, i_str_total, bef, be)


#########
#####
#



# BCA como ratio del PIB
pibn_añocierre <- datos$macro$pibn_añocierre
# Creamos una función para dividir la lista 'bca' en 'pibn'
ratio_pib <- function(element, pibn_añocierre) {
  if (is.numeric(element)) {
    # Si el elemento es numérico, divide
    element <- 100*(element / pibn_añocierre)
  } else if (is.data.frame(element) || is.list(element)) {
    element <- lapply(element, ratio_pib, pibn_añocierre = pibn_añocierre)
  }
  return(element)
}
# Aplicamos la función
bca_ratiopib <- lapply(bca, ratio_pib, pibn_añocierre = pibn_añocierre)
rm(pibn_añocierre)
bca_mpesos <- bca
rm(bca)



#########
#####
#
